-- MySQL Script generated by MySQL Workbench
-- Mon 28 Dec 2015 08:23:41 PM MSK
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema redmine_development
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema redmine_development
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `redmine_development` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci ;
USE `redmine_development` ;

-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_procedures`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_procedures` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_procedures` (
  `agreement_procedure_id` INT NOT NULL AUTO_INCREMENT,
  `agreement_procedure_name` VARCHAR(255) NULL,
  `project_id` INT NULL,
  `tracker_id` INT NULL,
  `issue_status_id` INT NULL,
  PRIMARY KEY (`agreement_procedure_id`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;

CREATE UNIQUE INDEX `uniidx` ON `redmine_development`.`agreement_procedures` (`issue_status_id` ASC, `project_id` ASC, `tracker_id` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_procedure_steps`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_procedure_steps` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_procedure_steps` (
  `agreement_procedure_step_id` INT NOT NULL AUTO_INCREMENT,
  `agreement_procedure_id` INT NOT NULL,
  `agreement_procedure_step` INT NOT NULL,
  `agreement_procedure_step_name` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`agreement_procedure_step_id`),
  CONSTRAINT `fk_agreement_procedures_steps_1`
    FOREIGN KEY (`agreement_procedure_id`)
    REFERENCES `redmine_development`.`agreement_procedures` (`agreement_procedure_id`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;

CREATE INDEX `agreementProcedure_id` ON `redmine_development`.`agreement_procedure_steps` (`agreement_procedure_id` ASC);

CREATE UNIQUE INDEX `uniidx` ON `redmine_development`.`agreement_procedure_steps` (`agreement_procedure_id` ASC, `agreement_procedure_step` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_signature_types`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_signature_types` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_signature_types` (
  `agreement_signature_type_id` INT NOT NULL AUTO_INCREMENT,
  `agreement_signature_type_name` VARCHAR(45) NOT NULL,
  `agreement_signature_type_registered_name` VARCHAR(45) NOT NULL,
  PRIMARY KEY (`agreement_signature_type_id`))
ENGINE = InnoDB
AUTO_INCREMENT = 3
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_signature_descriptions`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_signature_descriptions` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_signature_descriptions` (
  `agreement_signature_description_id` INT NOT NULL AUTO_INCREMENT,
  `agreement_signature_type_id` INT NULL,
  `agreement_signature_name` VARCHAR(45) NULL,
  `agreement_signature_tracker_id` INT NULL,
  PRIMARY KEY (`agreement_signature_description_id`),
  CONSTRAINT `fk_agreement_signature_description_1`
    FOREIGN KEY (`agreement_signature_type_id`)
    REFERENCES `redmine_development`.`agreement_signature_types` (`agreement_signature_type_id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_agreement_signature_description_1_idx` ON `redmine_development`.`agreement_signature_descriptions` (`agreement_signature_type_id` ASC);

CREATE INDEX `fk_agreement_signature_description_2_idx` ON `redmine_development`.`agreement_signature_descriptions` (`agreement_signature_tracker_id` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_list_agents`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_list_agents` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_list_agents` (
  `agent_id` INT NOT NULL AUTO_INCREMENT,
  `agent_name` VARCHAR(45) NULL,
  `agreement_signature_description_id` INT NOT NULL,
  `deputy_agent_id` INT NULL,
  `project_id` INT NOT NULL,
  PRIMARY KEY (`agent_id`),
  CONSTRAINT `fk_agreement_lists_agents_1`
    FOREIGN KEY (`agreement_signature_description_id`)
    REFERENCES `redmine_development`.`agreement_signature_descriptions` (`agreement_signature_description_id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE,
  CONSTRAINT `fk_agreement_list_agents_2`
    FOREIGN KEY (`deputy_agent_id`)
    REFERENCES `redmine_development`.`agreement_list_agents` (`agent_id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;

CREATE INDEX `deputy_agent_id` ON `redmine_development`.`agreement_list_agents` (`deputy_agent_id` ASC);

CREATE INDEX `fk_agreement_lists_agents_1_idx` ON `redmine_development`.`agreement_list_agents` (`agreement_signature_description_id` ASC);

CREATE INDEX `project_id` ON `redmine_development`.`agreement_list_agents` (`project_id` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_signatures`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_signatures` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_signatures` (
  `agreement_signature_id` INT NOT NULL AUTO_INCREMENT,
  `user_id` INT NOT NULL,
  `issue_id` INT NOT NULL,
  `agreement_step` INT NOT NULL,
  `agreement_signature_type_id` INT NOT NULL,
  `agreement_signature_registered_id` INT NOT NULL,
  `agreement_signature_ts` TIMESTAMP NULL DEFAULT NOW(),
  `agreement_signature_object` LONGBLOB NOT NULL,
  `agreement_signature_signature` LONGBLOB NOT NULL,
  `agreement_signature_verifydata` LONGBLOB NULL,
  PRIMARY KEY (`agreement_signature_id`),
  CONSTRAINT `fk_agreementSignatureType_id_fact`
    FOREIGN KEY (`agreement_signature_type_id`)
    REFERENCES `redmine_development`.`agreement_signature_types` (`agreement_signature_type_id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE)
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8
COLLATE = utf8_general_ci;

CREATE INDEX `fk_agreementSignatures_1_idx` ON `redmine_development`.`agreement_signatures` (`agreement_signature_type_id` ASC);

CREATE INDEX `issueStep` ON `redmine_development`.`agreement_signatures` (`issue_id` ASC, `agreement_step` ASC);

CREATE INDEX `userIssueStep` ON `redmine_development`.`agreement_signatures` (`user_id` ASC, `issue_id` ASC, `agreement_step` ASC);

CREATE INDEX `user` ON `redmine_development`.`agreement_signatures` (`user_id` ASC);

CREATE INDEX `type` ON `redmine_development`.`agreement_signatures` (`agreement_signature_type_id` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`user_lists`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`user_lists` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`user_lists` (
  `agreement_list_agent_id` INT NOT NULL,
  `user_id` INT NOT NULL,
  PRIMARY KEY (`user_id`, `agreement_list_agent_id`),
  CONSTRAINT `fk_user_lists_1`
    FOREIGN KEY (`agreement_list_agent_id`)
    REFERENCES `redmine_development`.`agreement_list_agents` (`agent_id`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `agreement_list_agent_id` ON `redmine_development`.`user_lists` (`agreement_list_agent_id` ASC);

CREATE INDEX `user_id` ON `redmine_development`.`user_lists` (`user_id` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_procedure_step_list_agents`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_procedure_step_list_agents` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_procedure_step_list_agents` (
  `agreement_procedure_step_list_agent_id` INT NOT NULL AUTO_INCREMENT,
  `agreement_list_agent_id` INT NULL,
  `agreement_procedure_step_id` INT NULL,
  PRIMARY KEY (`agreement_procedure_step_list_agent_id`),
  CONSTRAINT `fk_agreement_procedure_step_list_agents_1`
    FOREIGN KEY (`agreement_list_agent_id`)
    REFERENCES `redmine_development`.`agreement_list_agents` (`agent_id`)
    ON DELETE RESTRICT
    ON UPDATE CASCADE,
  CONSTRAINT `fk_agreement_procedure_step_list_agents_2`
    FOREIGN KEY (`agreement_procedure_step_id`)
    REFERENCES `redmine_development`.`agreement_procedure_steps` (`agreement_procedure_step_id`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_agreement_procedure_step_list_agents_1_idx` ON `redmine_development`.`agreement_procedure_step_list_agents` (`agreement_list_agent_id` ASC);

CREATE INDEX `fk_agreement_procedure_step_list_agents_2_idx` ON `redmine_development`.`agreement_procedure_step_list_agents` (`agreement_procedure_step_id` ASC);

CREATE UNIQUE INDEX `uniidx` ON `redmine_development`.`agreement_procedure_step_list_agents` (`agreement_list_agent_id` ASC, `agreement_procedure_step_id` ASC);


-- -----------------------------------------------------
-- Table `redmine_development`.`agreement_procedure_step_list_agent_fields`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `redmine_development`.`agreement_procedure_step_list_agent_fields` ;

CREATE TABLE IF NOT EXISTS `redmine_development`.`agreement_procedure_step_list_agent_fields` (
  `agreement_procedure_step_list_agent_field_id` INT NOT NULL AUTO_INCREMENT,
  `agreement_procedure_step_list_agent_id` INT NULL,
  `custom_field_id` INT NULL,
  `agreement_procedure_step_list_agent_field_type` SET('sign', 'edit') NOT NULL,
  PRIMARY KEY (`agreement_procedure_step_list_agent_field_id`),
  CONSTRAINT `fk_agreement_procedure_step_list_agent_fields_1`
    FOREIGN KEY (`agreement_procedure_step_list_agent_id`)
    REFERENCES `redmine_development`.`agreement_procedure_step_list_agents` (`agreement_procedure_step_list_agent_id`)
    ON DELETE CASCADE
    ON UPDATE CASCADE)
ENGINE = InnoDB;

CREATE INDEX `fk_agreement_procedure_step_list_agent_fields_1_idx` ON `redmine_development`.`agreement_procedure_step_list_agent_fields` (`agreement_procedure_step_list_agent_id` ASC);

CREATE UNIQUE INDEX `uniidx` ON `redmine_development`.`agreement_procedure_step_list_agent_fields` (`custom_field_id` ASC, `agreement_procedure_step_list_agent_id` ASC);

CREATE INDEX `custom_field_id` ON `redmine_development`.`agreement_procedure_step_list_agent_fields` (`custom_field_id` ASC);


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;

-- -----------------------------------------------------
-- Data for table `redmine_development`.`agreement_signature_types`
-- -----------------------------------------------------
START TRANSACTION;
USE `redmine_development`;
INSERT INTO `redmine_development`.`agreement_signature_types` (`agreement_signature_type_id`, `agreement_signature_type_name`, `agreement_signature_type_registered_name`) VALUES (1, 'Простая', 'simple');
INSERT INTO `redmine_development`.`agreement_signature_types` (`agreement_signature_type_id`, `agreement_signature_type_name`, `agreement_signature_type_registered_name`) VALUES (2, 'ЭЦП', 'eds');
INSERT INTO `redmine_development`.`agreement_signature_types` (`agreement_signature_type_id`, `agreement_signature_type_name`, `agreement_signature_type_registered_name`) VALUES (3, 'Квалифицированная', 'gov_eds');

COMMIT;


-- -----------------------------------------------------
-- Data for table `redmine_development`.`agreement_signature_descriptions`
-- -----------------------------------------------------
START TRANSACTION;
USE `redmine_development`;
INSERT INTO `redmine_development`.`agreement_signature_descriptions` (`agreement_signature_description_id`, `agreement_signature_type_id`, `agreement_signature_name`, `agreement_signature_tracker_id`) VALUES (1, 1, 'Простая', NULL);
INSERT INTO `redmine_development`.`agreement_signature_descriptions` (`agreement_signature_description_id`, `agreement_signature_type_id`, `agreement_signature_name`, `agreement_signature_tracker_id`) VALUES (2, 2, 'ЭЦП', NULL);
INSERT INTO `redmine_development`.`agreement_signature_descriptions` (`agreement_signature_description_id`, `agreement_signature_type_id`, `agreement_signature_name`, `agreement_signature_tracker_id`) VALUES (3, 3, 'Квалифицированная', NULL);

COMMIT;

